%def_enable SHARED
%def_enable X
%def_enable CONSOLE
%def_enable GPM
%def_enable LOCALE
%def_enable XMB
%def_disable XLOCALE
%def_enable XICON
%def_disable XTINIT
%def_disable HARD_REMAP
%def_enable LOGGING
%def_enable DEFAULT_CONFIG
%def_enable LINUX_CONSOLE

%define subst_on() %{expand:%%{?_enable_%{1}:-D%{1}=ON}} %{expand:%%{?_disable_%{1}:-D%{1}=OFF}}
%define subst_build() %{expand:%%{?_enable_%{1}:-DBUILD_%{1}=ON}} %{expand:%%{?_disable_%{1}:-DBUILD_%{1}=OFF}}
%define subst_use() %{expand:%%{?_enable_%{1}:-DUSE_%{1}=ON}} %{expand:%%{?_disable_%{1}:-DUSE_%{1}=OFF}}

%define Name eFTE
Name: efte
%define lname lib%name
Version: 0.98
Release: alt2
Summary: %Name Text Editor
License: %gpl2plus
Group: Editors
URL: http://%name.sourceforge.net
Source0: %name-%version.tar
Source1: %name.sh
Patch: %name-%version-%release.patch
%{?_enable_X:Requires: x%name = %version-%release}
%if_enabled CONSOLE
Requires: n%name = %version-%release
%else
%{?_enable_LINUX_CONSOLE:Requires: v%name = %version-%release}
%endif
Packager: Led <led@altlinux.ru>

BuildRequires(pre): rpm-build-licenses
BuildRequires: ccmake gcc-c++
%if_enabled X
BuildRequires: libXScrnSaver-devel libXau-devel libXcomposite-devel
BuildRequires: libXcursor-devel libXdamage-devel libXdmcp-devel
BuildRequires: libXext-devel libXft-devel libXi-devel libXinerama-devel
BuildRequires: libXpm-devel libXrandr-devel libXt-devel libXtst-devel
BuildRequires: libXv-devel libXxf86misc-devel libxkbfile-devel
BuildRequires: xorg-xf86vidmodeproto-devel ImageMagick-tools
%endif
%if_enabled CONSOLE
BuildRequires: libncurses-devel
%{?_enable_GPM:BuildRequires: libgpm-devel}
%endif
%if_enabled LINUX_CONSOLE
BuildRequires: libtinfo-devel
%{?_enable_GPM:BuildRequires: libgpm-devel}
%endif

%description
%Name is an advanced programmers editor with goals of being lightweight,
yet totally configurable. Support for user defined programming
languages, menu systems and key bindings are provided with many common
defaults already defined.
Folding:
  - Color syntax highlighting for many languages.
  - Smart indentation for C,C++,Java,Perl.
  - Fast. No mouse required.
  - File/line size limited by virtual memory.


%package common
Group: Editors
Summary: Common files for %Name Text Editor
BuildArch: noarch

%description common
%Name is an advanced programmers editor with goals of being lightweight,
yet totally configurable. Support for user defined programming
languages, menu systems and key bindings are provided with many common
defaults already defined.
Folding:
  - Color syntax highlighting for many languages.
  - Smart indentation for C,C++,Java,Perl.
  - Fast. No mouse required.
  - File/line size limited by virtual memory.

This package contains common files for variants of %Name.


%if_enabled SHARED
%package -n %lname
Group: System/Libraries
Summary: %Name Text Editor shared library

%description -n %lname
%Name is an advanced programmers editor with goals of being lightweight,
yet totally configurable. Support for user defined programming
languages, menu systems and key bindings are provided with many common
defaults already defined.
Folding:
  - Color syntax highlighting for many languages.
  - Smart indentation for C,C++,Java,Perl.
  - Fast. No mouse required.
  - File/line size limited by virtual memory.

This package contains %Name shared library.
%endif


%if_enabled X
%package -n x%name
Group: Editors
Summary: %Name Text Editor - X-Window variant
%{?_enable_SHARED:Requires: %lname = %version-%release}
Requires: %name-common = %version-%release

%description -n x%name
%Name is an advanced programmers editor with goals of being lightweight,
yet totally configurable. Support for user defined programming
languages, menu systems and key bindings are provided with many common
defaults already defined.
Folding:
  - Color syntax highlighting for many languages.
  - Smart indentation for C,C++,Java,Perl.
  - Fast. No mouse required.
  - File/line size limited by virtual memory.

This package contains common files for variants of %Name.
%endif


%if_enabled CONSOLE
%package -n n%name
Group: Editors
Summary: %Name Text Editor - ncurses variant
%{?_enable_SHARED:Requires: %lname = %version-%release}
Requires: %name-common = %version-%release

%description -n n%name
%Name is an advanced programmers editor with goals of being lightweight,
yet totally configurable. Support for user defined programming
languages, menu systems and key bindings are provided with many common
defaults already defined.
Folding:
  - Color syntax highlighting for many languages.
  - Smart indentation for C,C++,Java,Perl.
  - Fast. No mouse required.
  - File/line size limited by virtual memory.

This package contains ncurses variant of %Name.
%endif


%if_enabled LINUX_CONSOLE
%package -n v%name
Group: Editors
Summary: %Name Text Editor - variant for linux virtual console
%{?_enable_SHARED:Requires: %lname = %version-%release}
Requires: %name-common = %version-%release

%description -n v%name
%Name is an advanced programmers editor with goals of being lightweight,
yet totally configurable. Support for user defined programming
languages, menu systems and key bindings are provided with many common
defaults already defined.
Folding:
  - Color syntax highlighting for many languages.
  - Smart indentation for C,C++,Java,Perl.
  - Fast. No mouse required.
  - File/line size limited by virtual memory.

This package contains %Name variant for linux virtual console.
%endif


%prep
%setup
%patch -p1


%build
cmake \
    -DCMAKE_INSTALL_PREFIX=%_prefix \
    -DCMAKE_BUILD_TYPE=Release \
    -DCMAKE_C_FLAGS="%optflags" \
    -DCMAKE_VERBOSE_MAKEFILE=TRUE \
    %{subst_on SHARED} \
    %{subst_build X} \
    %{subst_build CONSOLE} \
    %{subst_build LINUX_CONSOLE} \
    %{subst_use GPM} \
    %{subst_use LOCALE} \
    %{subst_use XMB} \
    %{subst_use XLOCALE} \
    %{subst_use XICON} \
    %{subst_use XTINIT} \
    %{subst_use HARD_REMAP} \
    %{subst_use LOGGING} \
    %{subst_use DEFAULT_CONFIG} \
    .
%make_build
%if_enabled X
for s in 192 128 96 72 64 48 36 32 24 22 16; do
    convert -depth 8 -resize ${s}x$s packaging/shared/%name{512x512.xpm,-$s.png}
done
%endif


%install
%make_install DESTDIR=%buildroot install
%{?_enable_SHARED:[ "%_libdir" = "%_prefix/lib" ] || mv %buildroot{%_prefix/lib,%_libdir}}
rm -f %buildroot%_docdir/%name/{Artistic,COPYING}
rm -rf %buildroot%_pixmapsdir
install -m 0755 %SOURCE1 %buildroot%_bindir/%name
bzip2 --best %buildroot%_docdir/%name/HISTORY
mv %buildroot%_docdir/%name{,-%version}
%if_enabled X
mv %buildroot%_desktopdir/{,x}%name.desktop
for s in 192 128 96 72 64 48 36 32 24 22 16; do
    install -D -m 0644 {packaging/shared/%name-$s,%buildroot%_iconsdir/hicolor/${s}x$s/apps/x%name}.png
done
%endif

%{?_enable_SHARED:%add_verify_elf_skiplist %_libdir/*}


%files


%if_enabled SHARED
%files -n %lname
%_libdir/*
%endif


%files common
%_bindir/%name
%doc %_docdir/%name-%version/*
%_datadir/%name


%if_enabled X
%files -n x%name
%_bindir/x%name
%_iconsdir/hicolor/*/apps/*
%_desktopdir/*
%endif


%if_enabled CONSOLE
%files -n n%name
%_bindir/n%name
%endif


%if_enabled LINUX_CONSOLE
%files -n v%name
%_bindir/v%name
%endif


%changelog
* Sat Dec 27 2008 Led <led@altlinux.ru> 0.98-alt2
- fixed *.desktop

* Sun Dec 21 2008 Led <led@altlinux.ru> 0.98-alt1
- initial build
